[BACK]Return to ctfstrip CVS log [TXT][DIR] Up to [local] / src / usr.bin / ctfconv

File: [local] / src / usr.bin / ctfconv / ctfstrip (download)

Revision 1.7, Mon Aug 14 20:09:17 2017 UTC (6 years, 9 months ago) by jasper
Branch: MAIN
Changes since 1.6: +2 -2 lines

simplify LABEL extraction; from tb@

#!/bin/sh
#
# $OpenBSD: ctfstrip,v 1.7 2017/08/14 20:09:17 jasper Exp $
#
# Copyright (c) 2017 Martin Pieuchot
#
# Permission to use, copy, modify, and distribute this software for any
# purpose with or without fee is hereby granted, provided that the above
# copyright notice and this permission notice appear in all copies.
#
# THE SOFTWARE IS PROVIDED "AS IS" AND THE AUTHOR DISCLAIMS ALL WARRANTIES
# WITH REGARD TO THIS SOFTWARE INCLUDING ALL IMPLIED WARRANTIES OF
# MERCHANTABILITY AND FITNESS. IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR
# ANY SPECIAL, DIRECT, INDIRECT, OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES
# WHATSOEVER RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN
# ACTION OF CONTRACT, NEGLIGENCE OR OTHER TORTIOUS ACTION, ARISING OUT OF
# OR IN CONNECTION WITH THE USE OR PERFORMANCE OF THIS SOFTWARE.

set -o posix

cleanup() {
	rm -f ${TMPFILE}
	exit 1
}

trap "cleanup" 1 2 3 13 15

USAGE="usage: ${0##*/} [-S] [-o outfile] file"

for arg in "$@"; do
	if [ -n "$OSET" ]; then
		OUTFILE="$arg"
		unset OSET
		shift
		continue
	fi
	case "$arg" in
	-o)	OSET=1; shift; continue;;
	-S)	STRIPFLAG=-g; shift; continue;;
	esac
	shift
	set -- "$@" "$INFILE"
	INFILE="$arg"
done

if [ $# -eq 0 ]; then
	echo "${USAGE}" >&2
	exit 1
fi

LABEL="unknown"
TMPFILE=$(mktemp /tmp/.ctf.XXXXXXXXXX)

# Extract kernel version
if [ -z "${INFILE##bsd*}" ]; then
	LABEL=`what $INFILE | sed -n '$s/^   //p'`
fi

# If ctfstrip was passed a file that lacks useful debug sections, ctfconv will fail.
# So try to run ctfconv and silently fallback to plain strip(1) if that failed.
ctfconv -o ${TMPFILE} -l "${LABEL}" ${INFILE} 2> /dev/null

if [ $? -eq 0 ]; then
        objcopy --add-section .SUNW_ctf=${TMPFILE} ${STRIPFLAG} ${INFILE} ${OUTFILE}
else
        strip ${STRIPFLAG} $@ -o ${OUTFILE} ${INFILE}
fi

rm -f ${TMPFILE}